/*
 * @Author: your name
 * @Date: 2020-10-14 13:50:09
 * @LastEditTime: 2022-01-27 15:30:41
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Ed
 * @FilePath: \vue3-element-admin\src\main.js
 */
import { createApp ,computed, ref} from "vue";
import vue from "vue";
import axios from "@/plugins/axios";
import store from "@/store";
import installElementPlus from "@/plugins/element";
import elementIcon from "@/plugins/svgicon";
import permission from "@/plugins/permission";
import mock from "@/plugins/mock";
import directives from "@/directives";
import "normalize.css/normalize.css";
import "nprogress/nprogress.css";
import "@/styles/common.scss";
import App from "@/App.vue";
import router from "@/router";
import 'video.js/dist/video-js.css'
import '@/common/rem'
import Print from 'vue3-print-nb'

const app = createApp(App);
app.use(mock)
    .use(elementIcon)
    .use(installElementPlus)
    .use(store)
    .use(router)
    .use(axios, { router, store, opt: "VE_API" })
    .use(permission, { router, store })
    .use(directives, { router, store })
    .use(Print);


app.mount("#app");
